;Leap Anywhere

;This enables Gau's Leap command everywhere, not only on the Veldt,
;and changes the Leap command to only remove Gau from battle - not
;from the active party. Leap will only be enabled on formations
;that actually appear on the Veldt.

;xkas 0.06
hirom
;header

;---------------------------- OPTION A -----------------------------
;Always enable Dance in battle even if you don't know any Dance steps
;(idiot proof - prevents Leap if Gau is alone)
macro idiotCheck()
LDA $3A76		;Number of present and living characters in party
CMP #$02			
BCC .miss		;If less than 2, then miss w/ text
NOP #3
endmacro
macro noDance()
endmacro
!option0 = "dw $5449"		;Skip Dance check (jumps to RTS)
!option1 = %idiotCheck()	;Prevent Leap if Gau is the lone survivor
!option2 = "" ;%noDance()		;(Nothing)
;-------------------------------------------------------------------


;---------------------------- OPTION B -----------------------------
;Dance remains blanked out until at least one Dance step is learned
;(lets you annihilate yourself by Leaping a lone Gau)
;macro noIdiotCheck()
;endmacro
;macro dance()
;dance:	LDA $1D4C			;Bitfield of known Dances
;		BNE C23B71_exit
;		JMP C25432_null		;If none known, null menu entry
;		NOP #2
;endmacro
;!option0 = "dw dance"		;Check known Dances
;!option1 = "" ;%noIdiotCheck()
;!option2 = %dance()
;-------------------------------------------------------------------


;Dance menu entry pointer
org $C25460
C25460:	!option0

;Enable Leap everywhere
org $C25432
C25432:	BEQ .exit		;Leap jumps here
.null	LDA #$FF		;(Option B: Dance jumps here)
		STA $03,S		;Replace current command with empty
.exit	RTS 

org $C2543E
C2543E: LDA $2F4B
		BIT #$02		;Does formation appear on the Veldt?
		BRA C25432		;If not, menu entry will be nulled after branch

;Change Leap behaviour
org $C23B71
C23B71: !option1
		LDA $05,S
		TAX
		LDA $3DE9,X
		ORA #$20
		STA $3DE9,X    	;Mark Hide status to be set in attacker
		LDA $3018,X
		TSB $2F4C      	;Mark caster to be removed from the battlefield
		JSR $4A07 		;Learn rages
		STZ $3A6E      	;"End of combat" method #0, normal victory
.exit	RTS
	
.miss	LDA #$05	
		JMP $3B18      	;Miss target
		!option2
